
#include "mdfile.h"
#include "sha1.h"
#include "rmd160p.h"


struct HashContext {
    int Hash;
    int hashsize;
    union {
        struct MD5Context md5ctx;
        struct SHA1Context sha1ctx;
        struct RMDctx rmdctx;
    } ctx;
};

int HashSize(int Hash);

void HashInit(struct HashContext *context, int Hash);
void HashUpdate(struct HashContext *context, unsigned char const *buf, unsigned len);
void HashFinal(byte *buf, struct HashContext *context);
/*
void MD5Init(struct MD5Context *context);
void SHA1Init(struct SHA1Context *context);
void RMDinit(struct RMDctx *ctx);

void MD5Update(struct MD5Context *context, unsigned char const *buf, unsigned len);
void SHA1Update(struct SHA1Context *context, unsigned char const *buf, unsigned len);
void RMDUpdate(struct RMDctx *ctx, byte const * buf, unsigned len);

void MD5Final(unsigned char digest[16], struct MD5Context *context);
void SHA1Final(unsigned char digest[20], struct SHA1Context *context);
void RMDFinal(byte *buf, struct RMDctx *ctx);
*/


int Hashfile0_len(struct HashContext *context, FILE *f, word32 longcount, int Hash);
// Computes the message digest for a specified file
int Hashfile(struct HashContext *context, char *filename, int Hash);
// Used to finish the message digest, including extra material.
void Hash_addbuffer (struct HashContext *context, byte *buf, int buflen, byte *digest);

/*
int MDfile0_len(struct MD5Context *mdContext, FILE *f, word32 longcount);
int SHA1file0_len(struct SHA1Context *shContext, FILE * f, word32 longcount);
int RMDfile0_len(struct RMDctx *ctx, FILE * f, word32 longcount);

// Computes the message digest for a specified file
int MDfile(struct MD5Context *mdContext,char *filename);
int SHA1file(struct SHA1Context *shContext, char *filename);
int RMDfile(struct RMDctx *ctx, char *filename);

// Used to finish the message digest, including extra material.
void MD_addbuffer (struct MD5Context *mdContext, byte *buf, int buflen, byte digest[16]);
void SHA1_addbuffer(struct SHA1Context *shContext, byte * buf, int buflen, byte digest[20]);
void RMD_addbuffer(struct RMDctx *ctx, byte * buf, int buflen, byte digest[20])
*/
