/**
 * rijndael-alg-fst.h	v3.0	October '2000
 *
 * Optimised ANSI C code for the Rijndael cipher (now AES)
 *
 * @author Vincent Rijmen <vincent.rijmen@esat.kuleuven.ac.be>
 * @author Antoon Bosselaers <antoon.bosselaers@esat.kuleuven.ac.be>
 * @author Paulo Barreto <paulo.barreto@terra.com.br>
 *
 * This code is placed in the public domain.
 */
#ifndef __RIJNDAEL_ALG_FST_H
#define __RIJNDAEL_ALG_FST_H

#define MAXKC	(256/32)
#define MAXKB	(256/8)
#define MAXNR	14

#define R_ROUNDS128 10
#define R_ROUNDS192 12
#define R_ROUNDS256 14

#define RK_SIZE128 (4*(R_ROUNDS128+1))
#define RK_SIZE192 (4*(R_ROUNDS192+1))
#define RK_SIZE256 (4*(R_ROUNDS256+1))

int rijndaelKeySetupEnc(word32 rk[/*4*(Nr + 1)*/], const byte cipherKey[], int keyBits);
int rijndaelKeySetupDec(word32 rk[/*4*(Nr + 1)*/], const byte cipherKey[], int keyBits);
void rijndaelEncrypt(word32 rk[/*4*(Nr + 1)*/], int Nr, const byte pt[16], byte ct[16]);
void rijndaelDecrypt(word32 rk[/*4*(Nr + 1)*/], int Nr, const byte ct[16], byte pt[16]);

#ifdef INTERMEDIATE_VALUE_KAT
void rijndaelEncryptRound(const word32 rk[/*4*(Nr + 1)*/], int Nr, byte block[16], int rounds);
void rijndaelDecryptRound(const word32 rk[/*4*(Nr + 1)*/], int Nr, byte block[16], int rounds);
#endif /* INTERMEDIATE_VALUE_KAT */

#endif /* __RIJNDAEL_ALG_FST_H */
